// refresh time & rate
gRefreshTimer = null;
gRefreshRate = 60000;



function setup() {
    Localized.localizeDOM(document);
    document.getElementById('baladres').innerText = Localized.localizedString('Chaquejour');
    document.getElementById('actua').innerText = Localized.localizedString('Actua');
    document.getElementById('heur').innerText = Localized.localizedString('Heure');


	createGenericButton(document.getElementById("donePrefsButton"),Localized.localizedString('Done'),hidePrefs,60)
	document.getElementById("donePrefsButton").display = "none";
	// start refreshing image
	if (window.widget) {
		widget.onshow = onshow;
		widget.onhide = onhide;
		// get prefs
		rate = window.widget.preferenceForKey("refresh")
		if (rate && rate.length > 0) {
			gRefreshRate = rate
		}
		document.getElementById("refreshRate").value = gRefreshRate
	}
	refreshContent();
	gRefreshTimer = setInterval ("refreshContent();", gRefreshRate);

}

// handle the refresh
function changeRefreshRate(element)
{
	if (window.widget) {
		widget.setPreferenceForKey(element.value,"refresh");
		// change our interval timer
		clearInterval(gRefreshTimer);
		gRefreshTimer = setInterval("refreshContent();", gRefreshRate);
	}
}

function refreshContent()
{
	img = document.getElementById("watchedImage");

	img.src = "http://www.fugitif.net/ce/jour/thumb.jpg?dummy=" + Math.random();
}

function onshow()
{
	if (gRefreshTimer == null) {
		refreshContent();
		gRefreshTimer = setInterval("refreshContent();", gRefreshRate);
	}
}

function onhide()
{
	if (gRefreshTimer != null) {
		clearInterval(gRefreshTimer);
		gRefreshTimer = null;
	}
}


// everything below here handles showing and flipping to the prefs on the back and back again...
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
	widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	document.getElementById("donePrefsButton").display = "block";

	if (window.widget)
	setTimeout ('widget.performTransition();', 0);
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
	widget.prepareForTransition("ToFront");

	back.style.display="none";
	document.getElementById("donePrefsButton").display = "none";
	front.style.display="block";

	if (window.widget)
	setTimeout ('widget.performTransition();', 0);
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
	if (!flipShown)
	{
	if (animation.timer != null)
	{
		clearInterval (animation.timer);
		animation.timer	 = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = 1.0;
	animate();
	flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
	// fade in the info button
	if (animation.timer != null)
	{
		clearInterval (animation.timer);
		animation.timer	 = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = 0.0;
	animate();
	flipShown = false;
	}
}
function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();


	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
	clearInterval (animation.timer);
	animation.timer = null;
	animation.now = animation.to;
	}
	else
	{
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
	animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}
